'use strict';

var _interopRequireDefault = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _EventEmitter2 = require('eventemitter3');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

var _assign = require('object-assign');

var _assign2 = _interopRequireDefault(_assign);

var Store = (function (_EventEmitter) {
    function Store() {
        _classCallCheck(this, Store);

        if (_EventEmitter != null) {
            _EventEmitter.apply(this, arguments);
        }
    }

    _inherits(Store, _EventEmitter);

    _createClass(Store, [{
        key: 'handleAction',

        /**
         * Register an action handler
         * @param  {String}   id      Id of the action (e.g. 'todos.create')
         * @param  {Function} handler Action handler
         * @return {void}
         */
        value: function handleAction(id, handler) {
            if (!this._handlers) this._handlers = {};

            if (typeof handler !== 'function') {
                throw new Error('Handler for action ' + id + ' is not a function. ' + ('Attempted to register action handler in ' + this.constructor.name + '.'));
            }
            if (!this._actionIdExists(id)) {
                throw new Error('Action ' + id + ' does not exist. ' + ('Attempted to register action handler in ' + this.constructor.name + '.'));
            }
            if (this._handlers[id]) {
                throw new Error('Handler for action ' + id + ' is already registered. ' + ('Attempted to register action handler in ' + this.constructor.name + '.'));
            }

            this._handlers[id] = handler.bind(this);
        }
    }, {
        key: 'stopHandleAction',

        /**
         * Unregister an action handler
         * @param  {String} id  Id of the action (e.g. 'todos.create')
         * @return {void}
         */
        value: function stopHandleAction(id) {
            if (!id || !this._handlers || !this._handlers[id]) {
                return;
            }this._handlers[id] = undefined;
        }
    }, {
        key: 'setState',

        /**
         * Set state
         * @param {Object} state State object
         */
        value: function setState(state) {
            var options = arguments[1] === undefined ? {} : arguments[1];

            if (!state) {
                return;
            }if (!this.state) this.state = {};
            this.state = _assign2['default']({}, this.state, state);

            if (options.silent !== true) {
                this.emit('change', this.state);
            }
        }
    }, {
        key: 'getState',

        /**
         * Returns the state
         * @return {Object} The state object
         */
        value: function getState() {
            return this.state || {};
        }
    }, {
        key: '_actionIdExists',

        /**
         * Check if action id exists
         * @return {Boolean}
         */
        value: function _actionIdExists(id) {
            // This method will be overriden by the dispatcher.
            // When testing stores without the dispatcher, always return true
            return true;
        }
    }]);

    return Store;
})(_EventEmitter3['default']);

exports['default'] = Store;
module.exports = exports['default'];